Bug 1253244 - Review Request: uClibc-ng - C library for embedded Linux
Review Request: uClibc-ng - C library for embedded Linux
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Christopher Meng
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1246847
  Show dependency treegraph
 
Reported: 2015-08-13 06:20 EDT by Nikola Forró
Modified: 2015-09-24 09:21 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-09-24 09:21:58 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
licensecheck of uClibc-ng (237.51 KB, text/plain)
2015-08-25 07:44 EDT, Christopher Meng
no flags Details

  None (edit)
Description Nikola Forró 2015-08-13 06:20:41 EDT
Spec URL: https://nforro.fedorapeople.org/uClibc-ng.spec
SRPM URL: https://nforro.fedorapeople.org/uClibc-ng-1.0.5-1.fc22.src.rpm
Koji scratchbuild URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=10688606

Description:
uClibc-ng is a small C library for developing embedded Linux systems.
It is much smaller than the GNU C Library, but nearly all applications
supported by glibc also work perfectly with uClibc-ng.

Fedora Account System Username: nforro

rpmlint output:
$ rpmlint uClibc-ng.spec SRPMS/uClibc-ng-1.0.5-1.fc22.src.rpm
uClibc-ng.src: W: spelling-error %description -l en_US glibc -> glib, glib c
1 packages and 1 specfiles checked; 0 errors, 1 warnings.
Comment 1 Nikola Forró 2015-08-13 06:23:40 EDT
uClibc-ng replaces uClibc. Here is review request of the original package: https://bugzilla.redhat.com/show_bug.cgi?id=506720
Comment 2 Nikola Forró 2015-08-24 03:48:17 EDT
Updated to latest upstream version.

Spec URL: https://nforro.fedorapeople.org/uClibc-ng.spec
SRPM URL: https://nforro.fedorapeople.org/uClibc-ng-1.0.6-1.fc22.src.rpm
Koji scratchbuild URL: http://koji.fedoraproject.org/koji/taskinfo?taskID=10802019
Comment 3 Christopher Meng 2015-08-25 07:42:39 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated




===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v2 or later) (with incorrect FSF
     address)", "LGPL (v2.1 or later) (with incorrect FSF address)", "LGPL
     (v2 or later)", "GPL (v2 or later)", "Unknown or generated", "BSD (4
     clause)", "BSD (3 clause) ISC", "*No copyright* LGPL (v2 or later)",
     "LGPL (v2 or later) (with incorrect FSF address)", "ISC", "BSD (3
     clause) ISC LGPL (v2 or later)", "LGPL (v2)", "Beerware", "*No
     copyright* BSD", "BSD (3 clause)", "BSD (2 clause)", "LGPL (v2.1 or
     later)", "*No copyright* LGPL (v2.1 or later)", "GPL (v2)", "BSD ISC",
     "BSD (3 clause) LGPL (v2.1 or later)". 2372 files have unknown
     license. Detailed output of licensecheck is available at attachment.

[?]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/include/uClibc/bits
     (uClibc-devel), /usr/include/uClibc/neteconet(uClibc-devel),
     /usr/include/uClibc/sys(uClibc-devel), /usr/include/uClibc/scsi
     (uClibc-devel), /usr/include/uClibc/rpc(uClibc-devel),
     /usr/include/uClibc/netpacket(uClibc-devel),
     /usr/include/uClibc/protocols(uClibc-devel), /usr/include/uClibc/net
     (uClibc-devel), /usr/include/uClibc/arpa(uClibc-devel),
     /usr/include/uClibc/netipx(uClibc-devel), /usr/include/uClibc/netax25
     (uClibc-devel), /usr/include/uClibc(uClibc-devel),
     /usr/include/uClibc/netinet(uClibc-devel), /usr/lib/uClibc(uClibc-
     devel)
[?]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[?]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Static libraries in -static or -devel subpackage, providing -devel if
     present.
     Note: Package has .a files: uClibc-ng-devel.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: uClibc-ng-devel-1.0.6-1.fc24.i686.rpm
          uClibc-ng-1.0.6-1.fc24.src.rpm
uClibc-ng-devel.i686: W: spelling-error %description -l en_US glibc -> glib, glib c
uClibc-ng.src: W: spelling-error %description -l en_US glibc -> glib, glib c
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
1 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
uClibc-ng-devel (rpmlib, GLIBC filtered):



Provides
--------
uClibc-ng-devel:
    uClibc-devel
    uClibc-ng-devel
    uClibc-ng-devel(x86-32)
    uClibc-ng-static
    uClibc-static



Source checksums
----------------
http://downloads.uclibc-ng.org/releases/1.0.6/uClibc-ng-1.0.6.tar.xz :
  CHECKSUM(SHA256) this package     : afb2ec318fe5b115165e3fdc22964a2fd2b68e03a652ac36164ed096b4bb795c
  CHECKSUM(SHA256) upstream package : afb2ec318fe5b115165e3fdc22964a2fd2b68e03a652ac36164ed096b4bb795c


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -rvn uClibc-ng-1.0.6-1.fc22.src.rpm
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
-----------------------------------------------------------------------------

I'd ask some question here.

1. I don't see the reason that uclibc-ng should obsolete uclibc, at least. not "more suitable for different software development processes.", POC?

Fedora switches uclibc-ng may cause troubles to downstream folks or just users, have you measured the actual impact? As far as I can see from upstream, "This might change in the future".

If uclibc FTBFS, or no active upstream activities, then it's time to do the retire, but not now *I think*. Especially from upstream git I still can see commits in the past 3 years after its latest release.

2. I'm not sure if uclibc in Fedora is a package or just another c lib, if just a package ,you still need to build it with %optflags (UCLIBC_EXTRA_CFLAGS)

3. About these 2, should they be enabled?

Wide Character Support (UCLIBC_HAS_WCHAR) [N/y/?] n
Locale Support (UCLIBC_HAS_LOCALE) [N/y/?] n
Comment 4 Christopher Meng 2015-08-25 07:44:04 EDT
Created attachment 1066828 [details]
licensecheck of uClibc-ng
Comment 5 Nikola Forró 2015-08-25 10:40:10 EDT
As far as I know, uClibc package in Fedora exists only to enable static linking with busybox. Nothing else depends on it, and it's practical use is limited because it only contains static library and headers. From this point of view, I think replacing it with uClibc-ng is acceptable. Both libraries are very similar/compatible and busybox builds fine with uClibc-ng.
On the other hand, should there be more use cases than just building busybox, why don't let both libraries co-exist? 

(In reply to Christopher Meng from comment #3)
> 1. I don't see the reason that uclibc-ng should obsolete uclibc, at least.
> not "more suitable for different software development processes.", POC?
>
> Fedora switches uclibc-ng may cause troubles to downstream folks or just
> users, have you measured the actual impact? As far as I can see from
> upstream, "This might change in the future".
This is concerning only config file, so nothing that users should get in touch with.

> If uclibc FTBFS, or no active upstream activities, then it's time to do the
> retire, but not now *I think*. Especially from upstream git I still can see
> commits in the past 3 years after its latest release.
You are right, but there has been no uClibc release for 3 years, while uClibc-ng is released regularly. Also, uClibc-ng claims to implement changes happening in uClibc.

> 2. I'm not sure if uclibc in Fedora is a package or just another c lib, if
> just a package ,you still need to build it with %optflags
> (UCLIBC_EXTRA_CFLAGS)
Including %{optflags} would break busybox's goal to build smallest binary possible, I think. After all, that's the reason why busybox links with uClibc rather than glibc.

> 3. About these 2, should they be enabled?
> 
> Wide Character Support (UCLIBC_HAS_WCHAR) [N/y/?] n
> Locale Support (UCLIBC_HAS_LOCALE) [N/y/?] n
Again, I'm not sure how this would affect busybox. I should consult it's maintainer.
Comment 6 Christopher Meng 2015-08-26 23:57:03 EDT
(In reply to Nikola Forró from comment #5)
> > 2. I'm not sure if uclibc in Fedora is a package or just another c lib, if
> > just a package ,you still need to build it with %optflags
> > (UCLIBC_EXTRA_CFLAGS)
> Including %{optflags} would break busybox's goal to build smallest binary
> possible, I think. After all, that's the reason why busybox links with
> uClibc rather than glibc.

Ok,-fno-stack-protector -nostdinc, I understand.

> > 3. About these 2, should they be enabled?
> > 
> > Wide Character Support (UCLIBC_HAS_WCHAR) [N/y/?] n
> > Locale Support (UCLIBC_HAS_LOCALE) [N/y/?] n
> Again, I'm not sure how this would affect busybox. I should consult it's
> maintainer.

I've read the wchar code from uclibc, it's broken. ;)

PACKAGE APPROVED.
Comment 7 Nikola Forró 2015-09-24 09:21:58 EDT
I'm closing this review request, as replacing uClibc doesn't seem to be the best thing to do.

Note You need to log in before you can comment on or make changes to this bug.